%{

#include <stdio.h>
#include <string.h>
#include "fin.yacc.h"

%}

blancs     [\t\n ]+
lettre     [A-Za-z]
chiffre10  [0-9]
chiffre16  [0-9A-Fa-f]

indicateur {lettre}(_|{lettre}|{chiffre10})*
entier10   {chiffre10}+

minus  "-"
plus   "+"
mult   "*"
div    "/"
assign "="

linebreak \n
blank     [ \t]+

bracketb  "("
brackete  ")"
exclmark  "!"
colon     ":"
dot       "."
cbrackb   "{"
cbracke   "}"

%%

{indicateur} yylval = (int)strdup(yytext); return SYM_IDENT;
{indicateur}{plus}{plus} yylval = (int)strdup(yytext); return SYM_IDENT_PP;
{indicateur}{minus}{minus} yylval = (int)strdup(yytext); return SYM_IDENT_MM;

{cbrackb}{indicateur}{colon}{indicateur}?{cbracke} yylval = (int)strdup(yytext); return SYM_LABEL;

{assign}     return SYM_ASSIGN;
{entier10}   yylval = (int)strdup(yytext); return SYM_NUMBER;
{dot}        return SYM_METHOD;

{plus}       return SYM_OP_PLUS;
{minus}      return SYM_OP_MINUS;
{mult}       return SYM_OP_MULT;
{div}        return SYM_OP_DIV;

{bracketb}   return SYM_BRACKETB;
{brackete}   return SYM_BRACKETE;
{exclmark}   return SYM_EXCLMARK;
{colon}      return SYM_COLON;

{linebreak}  return SYM_BREAK;
{blank}      /**/

.            {yyerror("!!!");}

%%

