#include "jit.h"
#include <stdlib.h>
#include <string.h>

static char *jitter = NULL;
static int jitter_enabled = 0;

void jit_reset()
{
	if(jitter)
	{
		free(jitter);
		jitter = NULL;
	}
}

void jit_compile(const char *symbol)
{
	if(!jitter_enabled) return;

	jitter = (char*)realloc(jitter,
		(jitter ? strlen(jitter) : 0) + strlen(symbol) + 1);
	if(jitter) strcat(jitter, symbol);
	else strcpy(jitter, symbol);
}

const char *jit_execute()
{
	return jitter;
}

void jit_enable(int enabled)
{
	jitter_enabled = enabled;
}

