#include "store.h"
#include <stdlib.h>
#include <string.h>

#define HASH_CELLS 128

#define DEBUG 0

#if DEBUG
#define D(x) x
#else
#define D(x)
#endif

static char** variables[HASH_CELLS][2];

void store_init()
{
	int i;

	for(i = 0; i < HASH_CELLS; i++)
	{
		variables[i][0] = NULL;
		variables[i][1] = NULL;
	}
}

static int store_hash(const char *ident)
{
	int i;
	int hash = 0;

	for(i = 0; ident[i]; i++)
		hash = hash * 5 + ident[i];

	D(printf("** hash: %i %i\n", hash, hash % HASH_CELLS);)
	return hash % HASH_CELLS;
}

const char *store_transaction(const char *ident, const char *value)
{
	int i;
	int m = store_hash(ident);

	for(i = 0; variables[m][0] && variables[m][0][i]; i++)
	{
		D(printf("** store_transaction?: [%i] %s=%s\n", i,
			variables[m][0][i], variables[m][1][i]);)
		if(!strcmp(variables[m][0][i], ident))
		{
			if(value) variables[m][1][i] = strdup(value);
			return variables[m][1][i];
		}
	}

	D(printf("** store_transaction!: null\n");)
	variables[m][0] = (char**)realloc(variables[m][0], (i + 2) * sizeof(char*));
	variables[m][0][i] = strdup(ident);
	variables[m][0][i + 1] = NULL;
	variables[m][1] = (char**)realloc(variables[m][1], (i + 2) * sizeof(char*));
	variables[m][1][i] = (value ? strdup(value) : NULL);
	variables[m][1][i + 1] = NULL;

	return NULL;
}

void store_set(const char *ident, const char *value)
{
	D(printf("** store_set: %s=%s\n", ident, value);)
	store_transaction(ident, value);
}

const char *store_get(const char *ident)
{
	D(printf("** store_get: %s\n", ident);)
	return store_transaction(ident, NULL);
}

const char *store_method(const char *ident, const char *method)
{
	return "not-yet-implemented";
}

